// Decompiled by DJ v3.11.11.95 Copyright 2009 Atanas Neshkov  Date: 19/06/2011 02:18:31
// Home Page: http://members.fortunecity.com/neshkov/dj.html  http://www.neshkov.com/dj.html - Check often for new version!
// Decompiler options: packimports(3) 
// Source File Name:   tinyRPCMaster.java

package ininet.tinyRPC;

import java.awt.TextField;
import java.io.PrintStream;
import java.util.Properties;
import java.util.Vector;

// Referenced classes of package ininet.tinyRPC:
//            USBFileCommunication, USBwriteVal, USBILR

public class tinyRPCMaster
{

    public tinyRPCMaster()
        throws Exception
    {
        ilr = null;
        writeVal = null;
        tunnelString = null;
        TriggerRunningStateOff = false;
        if(singelton == null)
        {
            singelton = this;
            dataServerHashTable = new Properties();
            USBTrans = new USBFileCommunication();
            UNPWFields = new TextField[6];
        } else
        {
            throw new Exception("Singelton class!");
        }
    }

    public static tinyRPCMaster getInstance()
    {
        return singelton;
    }

    public boolean getFileTransferRunningState()
    {
        return USBTrans.getFileTransferRunningState();
    }

    public boolean getTriggerRunningStateOff()
    {
        return TriggerRunningStateOff;
    }

    public void setFileTransferRunningStateOff()
    {
        USBTrans.setFileTransferRunningStateOff();
    }

    public void setFileTransferRunningStateOn()
    {
        USBTrans.setFileTransferRunningStateOn();
    }

    public void setUNPWFields(TextField UN1, TextField UN2, TextField UN3, TextField PW1, TextField PW2, TextField PW3)
    {
        UNPWFields[0] = UN1;
        UNPWFields[1] = UN2;
        UNPWFields[2] = UN3;
        UNPWFields[3] = PW1;
        UNPWFields[4] = PW2;
        UNPWFields[5] = PW3;
    }

    private String String2Hex(String input)
    {
        String out = "";
        byte inputBytes[] = input.getBytes();
        for(int i = 0; i < input.length(); i++)
        {
            int current = inputBytes[i];
            if(current < 0)
                current = 256 + current;
            out = out + Integer.toHexString(current);
        }

        return out;
    }

    public String[] scanForError(String source, int offset)
    {
        String retVal[] = {
            " ", " "
        };
        int index = source.indexOf("<error", offset);
        if(index != -1)
        {
            index += "<error".length();
            index = source.indexOf("code=\"", index);
            if(index != -1)
            {
                index += "code=\"".length();
                int indexFNEnd = source.indexOf("\"", index);
                if(indexFNEnd != -1 && indexFNEnd > index)
                {
                    retVal[0] = source.substring(index, indexFNEnd);
                    index = indexFNEnd + 2;
                    indexFNEnd = source.indexOf("</error>", indexFNEnd);
                    if(indexFNEnd != -1)
                        retVal[1] = source.substring(index, indexFNEnd);
                    return retVal;
                }
            }
        }
        return retVal;
    }

    private int getIndexAfterNextElement(String rpc, int actualIndex)
    {
        int finalIndex = -1;
        String knownTypes[] = {
            "<string", "<int", "<bool", "<float", "<bin", "<ts"
        };
        int nrOfKnownTypes = 6;
        int currentIndex = rpc.indexOf(knownTypes[0], actualIndex);
        if(currentIndex != -1)
            finalIndex = currentIndex + knownTypes[0].length();
        for(int i = 1; i < nrOfKnownTypes; i++)
        {
            int nextIndex = rpc.indexOf(knownTypes[i], actualIndex);
            if(nextIndex != -1 && (nextIndex < currentIndex || currentIndex == -1))
            {
                currentIndex = nextIndex;
                finalIndex = currentIndex + knownTypes[i].length();
            }
        }

        return finalIndex;
    }

    private boolean scanTinyRpc(String rpc, int numParams, String startTagContent)
    {
        int index = 0;
        int index2 = 0;
        int paramCounter = 0;
        if(USBTrans.useListInsteadOfArray)
            USBTrans.fileAnswerParamsList.clear();
        index = rpc.indexOf(startTagContent);
        if(index != -1)
            index += startTagContent.length();
        while(paramCounter < numParams && index != -1) 
        {
            index = getIndexAfterNextElement(rpc, index);
            if(index != -1)
            {
                index2 = rpc.indexOf("</", index);
                if(index2 != -1 && rpc.charAt(index) != '/')
                {
                    if(USBTrans.useListInsteadOfArray)
                        USBTrans.fileAnswerParamsList.add(paramCounter, rpc.substring(index + 1, index2));
                    else
                        USBTrans.fileAnswerParams[paramCounter] = rpc.substring(index + 1, index2);
                } else
                if(rpc.charAt(index) == '/')
                {
                    if(USBTrans.useListInsteadOfArray)
                        USBTrans.fileAnswerParamsList.add(paramCounter, "");
                    else
                        USBTrans.fileAnswerParams[paramCounter] = "";
                } else
                {
                    return false;
                }
                paramCounter++;
            } else
            {
                return false;
            }
        }
        return true;
    }

    private int scanTinyRpcList(String rpc)
    {
        int index = 0;
        int index2 = 0;
        int paramCounter = 0;
        boolean parsing = true;
        index = rpc.indexOf("checksum=\"");
        index += 10;
        index2 = rpc.indexOf("\"", index);
        if(USBTrans.useListInsteadOfArray)
        {
            USBTrans.fileAnswerParamsList.add(paramCounter, rpc.substring(index, index2));
            paramCounter++;
        } else
        {
            USBTrans.fileAnswerParams[paramCounter++] = rpc.substring(index, index2);
        }
        while(parsing) 
            if(index != -1)
            {
                index = getIndexAfterNextElement(rpc, index);
                if(index != -1)
                {
                    index2 = rpc.indexOf("</", index);
                    if(index2 != -1 && rpc.charAt(index) != '/')
                    {
                        if(USBTrans.useListInsteadOfArray)
                            USBTrans.fileAnswerParamsList.add(paramCounter, rpc.substring(index + 1, index2));
                        else
                            USBTrans.fileAnswerParams[paramCounter] = rpc.substring(index + 1, index2);
                    } else
                    if(rpc.charAt(index) == '/')
                    {
                        if(USBTrans.useListInsteadOfArray)
                            USBTrans.fileAnswerParamsList.add(paramCounter, "");
                        else
                            USBTrans.fileAnswerParams[paramCounter] = "";
                    } else
                    {
                        return 0;
                    }
                    if(USBTrans.useListInsteadOfArray)
                        paramCounter++;
                    else
                    if(paramCounter < USBTrans.fileAnswerParams.length)
                    {
                        paramCounter++;
                    } else
                    {
                        System.out.println("paramCounter exceeded number of elements in array!!");
                        parsing = false;
                    }
                }
                index2 = rpc.indexOf(">", index2);
                if(rpc.indexOf("</list>", index2 + 1) - index2 < 2)
                    parsing = false;
            } else
            {
                parsing = false;
            }
        return paramCounter;
    }

    private int scanTinyRpcListNotListEnd(String rpc)
    {
        int index = 0;
        int index2 = 0;
        int paramCounter = 0;
        boolean parsing = true;
        index = rpc.indexOf("checksum=\"");
        index += 10;
        index2 = rpc.indexOf("\"", index);
        if(USBTrans.useListInsteadOfArray)
        {
            USBTrans.fileAnswerParamsList.add(paramCounter, rpc.substring(index, index2));
            paramCounter++;
        } else
        {
            USBTrans.fileAnswerParams[paramCounter++] = rpc.substring(index, index2);
        }
        while(parsing) 
            if(index != -1)
            {
                index = getIndexAfterNextElement(rpc, index);
                if(index != -1)
                {
                    index2 = rpc.indexOf("</", index);
                    if(index2 != -1 && rpc.charAt(index) != '/')
                    {
                        if(USBTrans.useListInsteadOfArray)
                            USBTrans.fileAnswerParamsList.add(paramCounter, rpc.substring(index + 1, index2));
                        else
                            USBTrans.fileAnswerParams[paramCounter] = rpc.substring(index + 1, index2);
                    } else
                    if(rpc.charAt(index) == '/')
                    {
                        if(USBTrans.useListInsteadOfArray)
                            USBTrans.fileAnswerParamsList.add(paramCounter, "");
                        else
                            USBTrans.fileAnswerParams[paramCounter] = "";
                    } else
                    {
                        return 0;
                    }
                    if(USBTrans.useListInsteadOfArray)
                        paramCounter++;
                    else
                    if(paramCounter < USBTrans.fileAnswerParams.length)
                    {
                        paramCounter++;
                    } else
                    {
                        System.out.println("paramCounter exceeded number of elements in array!!");
                        parsing = false;
                    }
                }
                index2 = rpc.indexOf(">", index2);
                if(rpc.indexOf("</args>", index2 + 1) - index2 < 2)
                    parsing = false;
            } else
            {
                parsing = false;
            }
        return paramCounter;
    }

    private boolean scanTinyRpcVectorFillDive(String rpc)
    {
        int index = 0;
        int index2 = 0;
        int testIndex = 0;
        int NumberOfHashes = 0;
        int endTagPositions[] = new int[5];
        USBTrans.hashVector = new Vector();
        USBTrans.hashContentVector = new Vector();
        while(testIndex != -1) 
        {
            testIndex = rpc.indexOf("<hash ref=", testIndex);
            if(testIndex != -1)
            {
                NumberOfHashes++;
                testIndex += 11;
            }
        }
        index = rpc.indexOf("checksum=\"");
        index += 10;
        index2 = rpc.indexOf("\"", index);
        if(index != -1 && index2 != -1 && index < index2)
        {
            if(USBTrans.useListInsteadOfArray)
                USBTrans.fileAnswerParamsList.add(0, rpc.substring(index, index2));
            else
                USBTrans.fileAnswerParams[0] = rpc.substring(index, index2);
        } else
        {
            return false;
        }
        index = getIndexAfterNextElement(rpc, index);
        if(index != -1)
        {
            index2 = rpc.indexOf("</", index);
            if(index2 != -1)
            {
                if(USBTrans.useListInsteadOfArray)
                    USBTrans.fileAnswerParamsList.add(1, rpc.substring(index + 1, index2));
                else
                    USBTrans.fileAnswerParams[1] = rpc.substring(index + 1, index2);
            } else
            {
                return false;
            }
        }
        for(int i = 0; i < NumberOfHashes; i++)
        {
            boolean endOfDiveHash = false;
            index = rpc.indexOf("<hash ref=\"", index);
            if(index != -1)
            {
                index += 11;
                index2 = rpc.indexOf("\"", index);
                if(index2 != -1)
                    USBTrans.hashContentVector.add(rpc.substring(index, index2));
            } else
            {
                return false;
            }
            index = rpc.indexOf("version=\"", index);
            if(index != -1)
            {
                index += 9;
                index2 = rpc.indexOf("\"", index);
                if(index2 != -1)
                    USBTrans.hashContentVector.add(rpc.substring(index, index2));
            } else
            {
                return false;
            }
            while(!endOfDiveHash) 
            {
                index = rpc.indexOf("<val key=\"", index);
                if(index != -1)
                {
                    index += 10;
                    index2 = rpc.indexOf("\"", index);
                }
                if(!rpc.substring(index, index2).equalsIgnoreCase("conditions") && !rpc.substring(index, index2).equalsIgnoreCase("gear") && !rpc.substring(index, index2).equalsIgnoreCase("buddies") && !rpc.substring(index, index2).equalsIgnoreCase("entries"))
                {
                    index = getIndexAfterNextElement(rpc, index);
                    if(index != -1)
                    {
                        index2 = rpc.indexOf("</", index);
                        if(index2 != -1 && rpc.charAt(index) != '/')
                            USBTrans.hashContentVector.add(rpc.substring(index + 1, index2));
                        else
                        if(rpc.charAt(index) == '/')
                            USBTrans.hashContentVector.add(" ");
                    }
                    index = rpc.indexOf("</val>", index);
                    if(index != -1)
                        index += 6;
                }
                endTagPositions[1] = rpc.indexOf("</list>", index);
                if(endTagPositions[1] == -1)
                    endTagPositions[1] = rpc.indexOf("<list/>", index);
                else
                if(rpc.indexOf("<list/>", index) != -1)
                    endTagPositions[1] = Math.min(rpc.indexOf("</list>", index), rpc.indexOf("<list/>", index));
                endTagPositions[2] = rpc.indexOf("</val>", index);
                endTagPositions[3] = rpc.indexOf("</hash>", endTagPositions[1] + 7);
                endTagPositions[4] = Math.min(rpc.indexOf("<hash", index), rpc.indexOf("<val", index));
                if(endTagPositions[1] != -1 && endTagPositions[1] < endTagPositions[2] && endTagPositions[2] < endTagPositions[3] && (endTagPositions[4] == -1 || endTagPositions[4] != -1 && endTagPositions[3] < endTagPositions[4]))
                    endOfDiveHash = true;
            }
            USBTrans.hashVector.add(new Vector(USBTrans.hashContentVector));
            USBTrans.hashContentVector = new Vector();
        }

        return true;
    }

    private boolean scanTinyRpcVectorFillUserSettings(String rpc)
    {
        int index = 0;
        int index2 = 0;
        int testIndex = 0;
        int NumberOfHashes = 0;
        int endTagPositions[] = new int[4];
        USBTrans.hashVector = new Vector();
        USBTrans.hashContentVector = new Vector();
        while(testIndex != -1) 
        {
            testIndex = rpc.indexOf("<hash ref=", testIndex);
            if(testIndex != -1)
            {
                NumberOfHashes++;
                testIndex += 11;
            }
        }
        index = rpc.indexOf("checksum=\"");
        index += 10;
        index2 = rpc.indexOf("\"", index);
        if(index != -1 && index2 != -1 && index < index2)
        {
            if(USBTrans.useListInsteadOfArray)
                USBTrans.fileAnswerParamsList.add(0, rpc.substring(index, index2));
            else
                USBTrans.fileAnswerParams[0] = rpc.substring(index, index2);
        } else
        {
            return false;
        }
        index = getIndexAfterNextElement(rpc, index);
        if(index != -1)
        {
            index2 = rpc.indexOf("</", index);
            if(index2 != -1)
            {
                if(USBTrans.useListInsteadOfArray)
                    USBTrans.fileAnswerParamsList.add(1, rpc.substring(index + 1, index2));
                else
                    USBTrans.fileAnswerParams[1] = rpc.substring(index + 1, index2);
            } else
            {
                return false;
            }
        }
        for(int i = 0; i < NumberOfHashes; i++)
        {
            boolean endOfUserSettingsHash = false;
            index = rpc.indexOf("<hash ref=\"", index);
            if(index != -1)
            {
                index += 11;
                index2 = rpc.indexOf("\"", index);
                if(index2 != -1)
                    USBTrans.hashContentVector.add(rpc.substring(index, index2));
            } else
            {
                return false;
            }
            index = rpc.indexOf("version=\"", index);
            if(index != -1)
            {
                index += 9;
                index2 = rpc.indexOf("\"", index);
                if(index2 != -1)
                    USBTrans.hashContentVector.add(rpc.substring(index, index2));
            } else
            {
                return false;
            }
            while(!endOfUserSettingsHash) 
            {
                index = rpc.indexOf("<val key=\"", index);
                if(index != -1)
                {
                    index += 10;
                    index2 = rpc.indexOf("\"", index);
                }
                if(rpc.substring(index, index2).equalsIgnoreCase("profile"))
                {
                    USBTrans.hashVector.add(new Vector(USBTrans.hashContentVector));
                    USBTrans.hashContentVector = new Vector();
                }
                if(!rpc.substring(index, index2).equalsIgnoreCase("education") && !rpc.substring(index, index2).equalsIgnoreCase("medical") && !rpc.substring(index, index2).equalsIgnoreCase("profile") && !rpc.substring(index, index2).equalsIgnoreCase("unit"))
                {
                    index = getIndexAfterNextElement(rpc, index);
                    if(index != -1)
                    {
                        index2 = rpc.indexOf("</", index);
                        if(index2 != -1 && rpc.charAt(index) != '/')
                            USBTrans.hashContentVector.add(rpc.substring(index + 1, index2));
                        else
                        if(rpc.charAt(index) == '/')
                            USBTrans.hashContentVector.add(" ");
                    }
                    index = rpc.indexOf("</val>", index);
                    if(index != -1)
                        index += 6;
                }
                endTagPositions[0] = rpc.indexOf("</hash>", index);
                endTagPositions[1] = rpc.indexOf("</val>", index);
                endTagPositions[2] = rpc.indexOf("</hash>", endTagPositions[0] + 1);
                endTagPositions[3] = Math.min(rpc.indexOf("<hash", index), rpc.indexOf("<val", index));
                if(endTagPositions[0] < endTagPositions[1] && endTagPositions[1] < endTagPositions[2] && (endTagPositions[3] == -1 || endTagPositions[3] != -1 && endTagPositions[2] < endTagPositions[3]))
                    endOfUserSettingsHash = true;
            }
            USBTrans.hashVector.add(new Vector(USBTrans.hashContentVector));
            USBTrans.hashContentVector = new Vector();
        }

        return true;
    }

    private boolean scanTinyRpcVectorFillDivespot(String rpc)
    {
        int index = 0;
        int index2 = 0;
        int testIndex = 0;
        int NumberOfHashes = 0;
        int endTagPositions[] = new int[2];
        String knownTypes[] = {
            "<string", "<int", "<bool", "<float", "<bin", "<ts"
        };
        int nrOfKnownTypes = 6;
        USBTrans.hashVector = new Vector();
        USBTrans.hashContentVector = new Vector();
        while(testIndex != -1) 
        {
            testIndex = rpc.indexOf("<hash ref=", testIndex);
            if(testIndex != -1)
            {
                NumberOfHashes++;
                testIndex += 11;
            }
        }
        index = rpc.indexOf("checksum=\"");
        index += 10;
        index2 = rpc.indexOf("\"", index);
        if(index != -1 && index2 != -1 && index < index2)
        {
            if(USBTrans.useListInsteadOfArray)
                USBTrans.fileAnswerParamsList.add(0, rpc.substring(index, index2));
            else
                USBTrans.fileAnswerParams[0] = rpc.substring(index, index2);
        } else
        {
            return false;
        }
        index = getIndexAfterNextElement(rpc, index);
        if(index != -1)
        {
            index2 = rpc.indexOf("</", index);
            if(index2 != -1)
            {
                if(USBTrans.useListInsteadOfArray)
                    USBTrans.fileAnswerParamsList.add(0, rpc.substring(index + 1, index2));
                else
                    USBTrans.fileAnswerParams[1] = rpc.substring(index + 1, index2);
            } else
            {
                return false;
            }
        }
        for(int i = 0; i < NumberOfHashes; i++)
        {
            boolean endOfDivespotHash = false;
            index = rpc.indexOf("<hash ref=\"", index);
            if(index != -1)
            {
                index += 11;
                index2 = rpc.indexOf("\"", index);
                if(index2 != -1)
                    USBTrans.hashContentVector.add(rpc.substring(index, index2));
            } else
            {
                return false;
            }
            index = rpc.indexOf("version=\"", index);
            if(index != -1)
            {
                index += 9;
                index2 = rpc.indexOf("\"", index);
                if(index2 != -1)
                    USBTrans.hashContentVector.add(rpc.substring(index, index2));
            } else
            {
                return false;
            }
            while(!endOfDivespotHash) 
            {
                index = rpc.indexOf("<val key=\"", index);
                if(index != -1)
                {
                    index += 10;
                    index2 = rpc.indexOf("\"", index);
                }
                index = getIndexAfterNextElement(rpc, index);
                if(index != -1)
                {
                    index2 = rpc.indexOf("</", index);
                    if(index2 != -1 && rpc.charAt(index) != '/')
                        USBTrans.hashContentVector.add(rpc.substring(index + 1, index2));
                    else
                    if(rpc.charAt(index) == '/')
                        USBTrans.hashContentVector.add(" ");
                }
                index = rpc.indexOf("</val>", index);
                if(index != -1)
                    index += 6;
                endTagPositions[0] = -1;
                for(int a = 0; a < nrOfKnownTypes; a++)
                    if(rpc.indexOf(knownTypes[a], index) != -1 && endTagPositions[0] == -1 || rpc.indexOf(knownTypes[a], index) != -1 && rpc.indexOf(knownTypes[a], index) < endTagPositions[0])
                        endTagPositions[0] = rpc.indexOf(knownTypes[a], index);

                endTagPositions[1] = rpc.indexOf("</hash>", index);
                if(endTagPositions[0] == -1 || endTagPositions[1] == -1 || endTagPositions[0] >= endTagPositions[1])
                    endOfDivespotHash = true;
            }
            USBTrans.hashVector.add(new Vector(USBTrans.hashContentVector));
            USBTrans.hashContentVector = new Vector();
        }

        return true;
    }

    public void USBwriteVal(String name, String value)
    {
        if(writeVal == null || !writeVal.isAlive())
        {
            USBTrans.writeVal_name = name;
            USBTrans.writeVal_value = value;
            writeVal = new USBwriteVal(USBTrans, dataServerHashTable);
            writeVal.start();
        } else
        {
            writeVal.addPPO2Chain(name, value);
        }
    }

    public String USBreadVal(String request)
    {
        String tmpName = "";
        String tmpVal = "";
        int index = 0;
        int index2 = 0;
        String version = "";
        String client = "";
        String client_ver = "";
        String file_name = "";
        int item_list_size = 0;
        if(ilr == null || !ilr.isAlive())
        {
            USBTrans.readVal_request = request;
            ilr = new USBILR(dataServerHashTable, request, USBTrans);
            ilr.start();
        }
        index = request.indexOf("<version>");
        if(index != -1)
        {
            index2 = request.indexOf("</version>", index);
            if(index2 != -1)
                version = request.substring(index, index2);
        }
        index = request.indexOf("<client>");
        if(index != -1)
        {
            index2 = request.indexOf("</client>", index);
            if(index2 != -1)
                client = request.substring(index, index2);
        }
        index = request.indexOf("<client_ver>");
        if(index != -1)
        {
            index2 = request.indexOf("</client_ver>", index);
            if(index2 != -1)
                client_ver = request.substring(index, index2);
        }
        index = request.indexOf("<file_name>");
        if(index != -1)
        {
            index2 = request.indexOf("</file_name>", index);
            if(index2 != -1)
                file_name = request.substring(index, index2);
        }
        index = request.indexOf("<item_list_size>");
        if(index != -1)
        {
            index2 = request.indexOf("</item_list_size>", index);
            if(index2 != -1)
            {
                index += 16;
                item_list_size = Integer.parseInt(request.substring(index, index2));
            }
        }
        index = index2 + 17;
        String answer = request.substring(0, index);
        answer = answer + "<item_list>\r\n";
        for(int i = 0; i < item_list_size; i++)
        {
            index = request.indexOf("<n>", index);
            if(index != -1)
            {
                index += 3;
                index2 = request.indexOf("</n>", index);
                if(index2 != -1)
                {
                    tmpName = request.substring(index, index2);
                    tmpVal = dataServerHashTable.getProperty(tmpName);
                    if(tmpVal != null)
                    {
                        answer = answer + "<i><n>" + tmpName + "</n><v>" + tmpVal + "</v></i>";
                    } else
                    {
                        dataServerHashTable.setProperty(tmpName, "0");
                        answer = answer + "<i><n>" + tmpName + "</n><v>0</v></i>";
                    }
                }
            }
        }

        answer = answer + "</item_list></body>";
        return answer;
    }

    public String getDeviceId()
    {
        String answer = "";
        if(USBTrans.getMethodAnswer("getDeviceId", 0, 1))
            if(USBTrans.useListInsteadOfArray)
                answer = USBTrans.fileAnswerParamsList.get(0).toString();
            else
                answer = USBTrans.fileAnswerParams[0];
        return answer;
    }

    public String USBinitSession()
    {
        String sSynchronize = "";
        if(USBTrans.useListInsteadOfArray)
        {
            USBTrans.fileAnswerParamsList.clear();
            USBTrans.fileAnswerParamsList.add(0, "http://vpi.uemis.com/remote/" + tunnelString + "/webservice.xml");
            USBTrans.fileAnswerParamsList.add(1, "");
            USBTrans.fileAnswerParamsList.add(2, "");
            USBTrans.fileAnswerParamsList.add(3, "");
            USBTrans.fileAnswerParamsList.add(4, "");
            USBTrans.fileAnswerParamsList.add(5, "");
            USBTrans.fileAnswerParamsList.add(6, "");
            USBTrans.fileAnswerParamsList.add(7, "");
            USBTrans.fileAnswerParamsList.add(8, "");
            USBTrans.fileAnswerParamsList.add(9, "");
        } else
        {
            USBTrans.fileAnswerParams[0] = "http://vpi.uemis.com/remote/" + tunnelString + "/webservice.xml";
        }
        if(USBTrans.getMethodAnswer("initSession", 1, 6))
        {
            sSynchronize = "<?xml version=\"1.0\" encoding=\"utf-8\" standalone=\"no\"?>\n<!DOCTYPE tinyrpc SYSTEM \"tinyrpc.dtd\">\n<!--<!DOCTYPE tinyrpc PUBLIC \"-//Uemis//DTD TinyRPC 1.0//EN\" \"http://www.uemis.org/dtd/tinyrpc.dtd\"-->\n<tinyrpc><call><method>initSession</method>";
            if(USBTrans.useListInsteadOfArray)
                sSynchronize = sSynchronize + "<args checksum=\"" + USBTrans.fileAnswerParamsList.get(0).toString() + "\">" + "<int>" + USBTrans.fileAnswerParamsList.get(1).toString() + "</int>" + "<string>" + USBTrans.fileAnswerParamsList.get(2).toString() + "</string>" + "<string>" + USBTrans.fileAnswerParamsList.get(3).toString() + "</string>" + "<string>" + USBTrans.fileAnswerParamsList.get(4).toString() + "</string>" + "<string>" + USBTrans.fileAnswerParamsList.get(5).toString() + "</string>";
            else
                sSynchronize = sSynchronize + "<args checksum=\"" + USBTrans.fileAnswerParams[0] + "\">" + "<string>" + USBTrans.fileAnswerParams[1] + "</string>" + "<string>" + USBTrans.fileAnswerParams[2] + "</string>" + "<string>" + USBTrans.fileAnswerParams[3] + "</string>";
            sSynchronize = sSynchronize + "</args></call></tinyrpc>";
        }
        return sSynchronize;
    }

    public boolean USBinitSessionReturn(String response)
    {
        if(scanTinyRpc(response, 4, "<response>"))
            return USBTrans.getMethodAnswer("initSessionReturn", 4, 0);
        else
            return false;
    }

    public String USBrequestSync()
    {
        String sSynchronize = "";
        if(USBTrans.getMethodAnswer("requestSync", 0, 5))
        {
            sSynchronize = "<?xml version=\"1.0\" encoding=\"utf-8\" standalone=\"no\"?>\n<!DOCTYPE tinyrpc SYSTEM \"tinyrpc.dtd\">\n<!--<!DOCTYPE tinyrpc PUBLIC \"-//Uemis//DTD TinyRPC 1.0//EN\" \"http://www.uemis.org/dtd/tinyrpc.dtd\"-->\n<tinyrpc><call><method>requestSync</method>";
            if(!USBTrans.fileAnswerParamsList.get(0).toString().equalsIgnoreCase(" "))
            {
                if(USBTrans.useListInsteadOfArray)
                    sSynchronize = sSynchronize + "<args checksum=\"" + USBTrans.fileAnswerParamsList.get(0).toString() + "\">" + "<string>" + USBTrans.fileAnswerParamsList.get(1).toString() + "</string>" + "<string format=\"base64\" crypted=\"true\">" + USBTrans.fileAnswerParamsList.get(2).toString() + "</string>" + "<string>" + USBTrans.fileAnswerParamsList.get(3).toString() + "</string>" + "<int>" + USBTrans.fileAnswerParamsList.get(4).toString() + "</int>";
                else
                    sSynchronize = sSynchronize + "<args checksum=\"" + USBTrans.fileAnswerParams[0] + "\">" + "<string>" + USBTrans.fileAnswerParams[1] + "</string>" + "<string>" + USBTrans.fileAnswerParams[2] + "</string>" + "<string>" + USBTrans.fileAnswerParams[3] + "</string>" + "<int>" + USBTrans.fileAnswerParams[4] + "</int>";
                sSynchronize = sSynchronize + "</args></call></tinyrpc>";
            } else
            {
                sSynchronize = "";
            }
        }
        return sSynchronize;
    }

    public boolean USBrequestSyncReturn(String response)
    {
        if(scanTinyRpc(response, 1, "<response>"))
            return USBTrans.getMethodAnswer("requestSyncReturn", 1, 0);
        else
            return false;
    }

    public boolean USBgetLoginDataAvailable()
    {
        boolean Answer = false;
        if(USBTrans.getMethodAnswer("getLoginDataAvailable", 0, 3))
            if(USBTrans.useListInsteadOfArray)
            {
                if(USBTrans.fileAnswerParamsList.get(0).toString().equalsIgnoreCase("1"))
                {
                    Answer = true;
                    UNPWFields[0].setText(USBTrans.fileAnswerParamsList.get(1).toString());
                    UNPWFields[1].setText(USBTrans.fileAnswerParamsList.get(1).toString());
                    UNPWFields[2].setText(USBTrans.fileAnswerParamsList.get(1).toString());
                    UNPWFields[3].setText(USBTrans.fileAnswerParamsList.get(2).toString());
                    UNPWFields[4].setText(USBTrans.fileAnswerParamsList.get(2).toString());
                    UNPWFields[5].setText(USBTrans.fileAnswerParamsList.get(2).toString());
                }
            } else
            if(USBTrans.fileAnswerParams[0].equalsIgnoreCase("1"))
                Answer = true;
        return Answer;
    }

    public boolean USBalreadyRegistered()
    {
        boolean Answer = false;
        if(USBTrans.getMethodAnswer("alreadyRegistered", 0, 1))
            if(USBTrans.useListInsteadOfArray)
            {
                if(USBTrans.fileAnswerParamsList.get(0).toString().equalsIgnoreCase("1"))
                    Answer = true;
            } else
            if(USBTrans.fileAnswerParams[0].equalsIgnoreCase("1"))
                Answer = true;
        return Answer;
    }

    public String USBrequestRegistration()
    {
        String sSynchronize = "";
        if(USBTrans.getMethodAnswer("requestRegistration", 0, 5))
        {
            sSynchronize = "<?xml version=\"1.0\" encoding=\"utf-8\" standalone=\"no\"?>\n<!DOCTYPE tinyrpc SYSTEM \"tinyrpc.dtd\">\n<!--<!DOCTYPE tinyrpc PUBLIC \"-//Uemis//DTD TinyRPC 1.0//EN\" \"http://www.uemis.org/dtd/tinyrpc.dtd\"-->\n<tinyrpc><call><method>requestRegistration</method>";
            if(!USBTrans.fileAnswerParamsList.get(0).toString().equalsIgnoreCase(" "))
            {
                if(USBTrans.useListInsteadOfArray)
                    sSynchronize = sSynchronize + "<args checksum=\"" + USBTrans.fileAnswerParamsList.get(0).toString() + "\">" + "<string>" + USBTrans.fileAnswerParamsList.get(1).toString() + "</string>" + "<string format=\"base64\" crypted=\"true\">" + USBTrans.fileAnswerParamsList.get(2).toString() + "</string>" + "<string>" + USBTrans.fileAnswerParamsList.get(3).toString() + "</string>" + "<int>" + USBTrans.fileAnswerParamsList.get(4).toString() + "</int>";
                else
                    sSynchronize = sSynchronize + "<args checksum=\"" + USBTrans.fileAnswerParams[0] + "\">" + "<string>" + USBTrans.fileAnswerParams[1] + "</string>" + "<string>" + USBTrans.fileAnswerParams[2] + "</string>" + "<string>" + USBTrans.fileAnswerParams[3] + "</string>" + "<int>" + USBTrans.fileAnswerParams[4] + "</int>";
                sSynchronize = sSynchronize + "</args></call></tinyrpc>";
            } else
            {
                sSynchronize = "";
            }
        }
        return sSynchronize;
    }

    public boolean USBrequestRegistrationReturn(String response)
    {
        if(scanTinyRpc(response, 1, "<response>"))
            return USBTrans.getMethodAnswer("requestRegistrationReturn", 1, 0);
        else
            return false;
    }

    public void USBstoreLoginData(String Username, String Password, boolean storePermanently)
    {
        if(USBTrans.useListInsteadOfArray)
        {
            USBTrans.fileAnswerParamsList.clear();
            USBTrans.fileAnswerParamsList.add(0, Username);
            USBTrans.fileAnswerParamsList.add(1, Password);
            if(storePermanently)
                USBTrans.fileAnswerParamsList.add(2, "1");
            else
                USBTrans.fileAnswerParamsList.add(2, "0");
            USBTrans.fileAnswerParamsList.add(3, "");
            USBTrans.fileAnswerParamsList.add(4, "");
            USBTrans.fileAnswerParamsList.add(5, "");
            USBTrans.fileAnswerParamsList.add(6, "");
            USBTrans.fileAnswerParamsList.add(7, "");
            USBTrans.fileAnswerParamsList.add(8, "");
            USBTrans.fileAnswerParamsList.add(9, "");
        } else
        {
            USBTrans.fileAnswerParams[0] = Username;
            USBTrans.fileAnswerParams[1] = Password;
        }
        USBTrans.getMethodAnswer("storeLoginData", 3, 0);
    }

    public String USBprocessSync()
    {
        String sSynchronize = "";
        if(USBTrans.getMethodAnswer("processSync", 0, 2))
        {
            sSynchronize = "<?xml version=\"1.0\" encoding=\"utf-8\" standalone=\"no\"?>\n<!DOCTYPE tinyrpc SYSTEM \"tinyrpc.dtd\">\n<!--<!DOCTYPE tinyrpc PUBLIC \"-//Uemis//DTD TinyRPC 1.0//EN\" \"http://www.uemis.org/dtd/tinyrpc.dtd\"-->\n<tinyrpc><call><method>processSync</method>";
            if(USBTrans.useListInsteadOfArray)
                sSynchronize = sSynchronize + "<args checksum=\"" + USBTrans.fileAnswerParamsList.get(0).toString() + "\">" + "<string>" + USBTrans.fileAnswerParamsList.get(1).toString() + "</string>";
            else
                sSynchronize = sSynchronize + "<args checksum=\"" + USBTrans.fileAnswerParams[0] + "\">" + "<string>" + USBTrans.fileAnswerParams[1] + "</string>";
            sSynchronize = sSynchronize + "</args></call></tinyrpc>";
        }
        return sSynchronize;
    }

    public boolean USBrestoreDatabase()
    {
        boolean RestoreSuccess = false;
        USBTrans.getMethodAnswer("restoreDatabase", 0, 1);
        if(USBTrans.useListInsteadOfArray)
        {
            if(USBTrans.fileAnswerParamsList.get(0).toString().equalsIgnoreCase("1"))
                RestoreSuccess = true;
        } else
        if(USBTrans.fileAnswerParams[0].equalsIgnoreCase("1"))
            RestoreSuccess = true;
        return RestoreSuccess;
    }

    public void USBchangeUser()
    {
        USBTrans.getMethodAnswer("changeUser", 0, 0);
    }

    public String USBprocessRestore()
    {
        String sSynchronize = "";
        if(USBTrans.getMethodAnswer("processRestore", 0, 2))
        {
            sSynchronize = "<?xml version=\"1.0\" encoding=\"utf-8\" standalone=\"no\"?>\n<!DOCTYPE tinyrpc SYSTEM \"tinyrpc.dtd\">\n<!--<!DOCTYPE tinyrpc PUBLIC \"-//Uemis//DTD TinyRPC 1.0//EN\" \"http://www.uemis.org/dtd/tinyrpc.dtd\"-->\n<tinyrpc><call><method>processRestore</method>";
            if(USBTrans.useListInsteadOfArray)
                sSynchronize = sSynchronize + "<args checksum=\"" + USBTrans.fileAnswerParamsList.get(0).toString() + "\">" + "<string>" + USBTrans.fileAnswerParamsList.get(1).toString() + "</string>";
            else
                sSynchronize = sSynchronize + "<args checksum=\"" + USBTrans.fileAnswerParams[0] + "\">" + "<string>" + USBTrans.fileAnswerParams[1] + "</string>";
            sSynchronize = sSynchronize + "</args></call></tinyrpc>";
        } else
        {
            System.out.println("getMethodAnswer with processRestore did not succeed");
        }
        return sSynchronize;
    }

    public boolean USBisFirmwareUpdateAllowed()
    {
        boolean ret = false;
        if(USBTrans.getMethodAnswer("isFirmwareUpdateAllowed", 0, 1))
            if(USBTrans.useListInsteadOfArray)
            {
                if(USBTrans.fileAnswerParamsList.get(0).toString().equalsIgnoreCase("1"))
                    ret = true;
            } else
            if(USBTrans.fileAnswerParams[0].equalsIgnoreCase("1"))
                ret = true;
        return ret;
    }

    public String[] USBprepareFirmwareCopy()
    {
        String Answer[] = new String[3];
        if(USBTrans.getMethodAnswer("prepareFirmwareCopy", 0, 3))
            if(USBTrans.useListInsteadOfArray)
            {
                Answer[0] = USBTrans.fileAnswerParamsList.get(0).toString();
                Answer[1] = USBTrans.fileAnswerParamsList.get(1).toString();
                Answer[2] = USBTrans.fileAnswerParamsList.get(2).toString();
            } else
            {
                Answer[0] = USBTrans.fileAnswerParams[0];
                Answer[1] = USBTrans.fileAnswerParams[1];
                Answer[2] = USBTrans.fileAnswerParams[2];
            }
        return Answer;
    }

    public boolean DoFirmwareCopy()
    {
        boolean returnVal = false;
        if(USBTrans.getMethodAnswer("doFirmwareCopy", 0, 0))
            returnVal = true;
        return returnVal;
    }

    public String USBputUserSettings(String request)
    {
        String answer = "";
        if(scanTinyRpcVectorFillUserSettings(request) && USBTrans.getMethodAnswer("putUserSettings", 2, 0))
            if(USBTrans.useListInsteadOfArray)
            {
                if(!USBTrans.fileAnswerParamsList.get(0).toString().equalsIgnoreCase("error"))
                {
                    answer = "<string>" + USBTrans.fileAnswerParamsList.get(0).toString() + "</string>\r\n" + "<list>\r\n";
                    for(int i = 0; i < USBTrans.hashVector.size(); i++)
                    {
                        answer = answer + "<hash ref=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(0) + "\" version=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(1) + "\">\r\n";
                        for(int j = 0; j < (((Vector)USBTrans.hashVector.elementAt(i)).size() - 2) / 3; j++)
                            answer = answer + "<val key=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 2) + "\">\r\n<" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 1 + 2) + ">" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 2 + 2) + "</" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 1 + 2) + "></val>";

                        answer = answer + "</hash>\r\n";
                    }

                    answer = answer + "</list>";
                } else
                {
                    answer = "<error code=\"" + ((Vector)USBTrans.hashVector.elementAt(0)).elementAt(0) + "\">" + ((Vector)USBTrans.hashVector.elementAt(0)).elementAt(1) + "</error>";
                    if(((String)((Vector)USBTrans.hashVector.elementAt(0)).elementAt(0)).equalsIgnoreCase("600"))
                        setFileTransferRunningStateOff();
                }
            } else
            if(!USBTrans.fileAnswerParams[0].equalsIgnoreCase("error"))
            {
                answer = "<string>" + USBTrans.fileAnswerParams[0] + "</string>\r\n" + "<list>\r\n";
                for(int i = 0; i < USBTrans.hashVector.size(); i++)
                {
                    answer = answer + "<hash ref=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(0) + "\" version=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(1) + "\">\r\n";
                    for(int j = 0; j < (((Vector)USBTrans.hashVector.elementAt(i)).size() - 2) / 3; j++)
                        answer = answer + "<val key=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 2) + "\">" + "<" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 1 + 2) + ">" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 2 + 2) + "</" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 1 + 2) + ">\r\n" + "</val>\r\n";

                    answer = answer + "</hash>\r\n";
                }

                answer = answer + "</list>";
            } else
            {
                answer = "<error code=\"" + ((Vector)USBTrans.hashVector.elementAt(0)).elementAt(0) + "\">" + ((Vector)USBTrans.hashVector.elementAt(0)).elementAt(1) + "</error>";
                if(((String)((Vector)USBTrans.hashVector.elementAt(0)).elementAt(0)).equalsIgnoreCase("600"))
                    setFileTransferRunningStateOff();
            }
        return answer;
    }

    public String USBputDive(String request)
    {
        String answer = "";
        if(scanTinyRpcVectorFillDive(request) && USBTrans.getMethodAnswer("putDive", 2, 0))
            if(USBTrans.useListInsteadOfArray)
            {
                if(!USBTrans.fileAnswerParamsList.get(0).toString().equalsIgnoreCase("error"))
                {
                    answer = "<string>" + USBTrans.fileAnswerParamsList.get(0).toString() + "</string>\r\n" + "<list>\r\n";
                    for(int i = 0; i < USBTrans.hashVector.size(); i++)
                    {
                        answer = answer + "<hash ref=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(0) + "\" version=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(1) + "\">\r\n";
                        for(int j = 0; j < (((Vector)USBTrans.hashVector.elementAt(i)).size() - 2) / 3; j++)
                            answer = answer + "<val key=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 2) + "\">" + "<" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 1 + 2) + ">" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 2 + 2) + "</" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 1 + 2) + ">" + "</val>\r\n";

                        answer = answer + "</hash>\r\n";
                    }

                    answer = answer + "</list>";
                } else
                {
                    answer = "<error code=\"" + ((Vector)USBTrans.hashVector.elementAt(0)).elementAt(0) + "\">" + ((Vector)USBTrans.hashVector.elementAt(0)).elementAt(1) + "</error>";
                    if(((String)((Vector)USBTrans.hashVector.elementAt(0)).elementAt(0)).equalsIgnoreCase("600"))
                        setFileTransferRunningStateOff();
                }
            } else
            if(!USBTrans.fileAnswerParams[0].equalsIgnoreCase("error"))
            {
                answer = "<string>" + USBTrans.fileAnswerParams[0] + "</string>\r\n" + "<list>\r\n";
                for(int i = 0; i < USBTrans.hashVector.size(); i++)
                {
                    answer = answer + "<hash ref=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(0) + "\" version=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(1) + "\">\r\n";
                    for(int j = 0; j < (((Vector)USBTrans.hashVector.elementAt(i)).size() - 2) / 3; j++)
                        answer = answer + "<val key=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 2) + "\">" + "<" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 1 + 2) + ">" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 2 + 2) + "</" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 1 + 2) + ">" + "</val>\r\n";

                    answer = answer + "</hash>\r\n";
                }

                answer = answer + "</list>";
            } else
            {
                answer = "<error code=\"" + ((Vector)USBTrans.hashVector.elementAt(0)).elementAt(0) + "\">" + ((Vector)USBTrans.hashVector.elementAt(0)).elementAt(1) + "</error>";
                if(((String)((Vector)USBTrans.hashVector.elementAt(0)).elementAt(0)).equalsIgnoreCase("600"))
                    setFileTransferRunningStateOff();
            }
        return answer;
    }

    public String USBputChecklist(String request)
    {
        String answer = "";
        if(scanTinyRpcVectorFillDive(request) && USBTrans.getMethodAnswer("putChecklist", 2, 0))
            if(USBTrans.useListInsteadOfArray)
            {
                if(!USBTrans.fileAnswerParamsList.get(0).toString().equalsIgnoreCase("error"))
                {
                    answer = "<string>" + USBTrans.fileAnswerParamsList.get(0).toString() + "</string>\r\n" + "<list>\r\n";
                    for(int i = 0; i < USBTrans.hashVector.size(); i++)
                    {
                        answer = answer + "<hash ref=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(0) + "\" version=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(1) + "\">\r\n";
                        for(int j = 0; j < (((Vector)USBTrans.hashVector.elementAt(i)).size() - 2) / 3; j++)
                            answer = answer + "<val key=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 2) + "\">" + "<" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 1 + 2) + ">" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 2 + 2) + "</" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 1 + 2) + ">" + "</val>\r\n";

                        answer = answer + "</hash>\r\n";
                    }

                    answer = answer + "</list>";
                } else
                {
                    answer = "<error code=\"" + ((Vector)USBTrans.hashVector.elementAt(0)).elementAt(0) + "\">" + ((Vector)USBTrans.hashVector.elementAt(0)).elementAt(1) + "</error>";
                    if(((String)((Vector)USBTrans.hashVector.elementAt(0)).elementAt(0)).equalsIgnoreCase("600"))
                        setFileTransferRunningStateOff();
                }
            } else
            if(!USBTrans.fileAnswerParams[0].equalsIgnoreCase("error"))
            {
                answer = "<string>" + USBTrans.fileAnswerParams[0] + "</string>\r\n" + "<list>\r\n";
                for(int i = 0; i < USBTrans.hashVector.size(); i++)
                {
                    answer = answer + "<hash ref=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(0) + "\" version=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(1) + "\">\r\n";
                    for(int j = 0; j < (((Vector)USBTrans.hashVector.elementAt(i)).size() - 2) / 3; j++)
                        answer = answer + "<val key=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 2) + "\">" + "<" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 1 + 2) + ">" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 2 + 2) + "</" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 1 + 2) + ">" + "</val>\r\n";

                    answer = answer + "</hash>\r\n";
                }

                answer = answer + "</list>";
            } else
            {
                answer = "<error code=\"" + ((Vector)USBTrans.hashVector.elementAt(0)).elementAt(0) + "\">" + ((Vector)USBTrans.hashVector.elementAt(0)).elementAt(1) + "</error>";
                if(((String)((Vector)USBTrans.hashVector.elementAt(0)).elementAt(0)).equalsIgnoreCase("600"))
                    setFileTransferRunningStateOff();
            }
        return answer;
    }

    public String USBputDivespot(String request)
    {
        String answer = "";
        if(scanTinyRpcVectorFillDivespot(request) && USBTrans.getMethodAnswer("putDivespot", 2, 0))
            if(USBTrans.useListInsteadOfArray)
            {
                if(!USBTrans.fileAnswerParamsList.get(0).toString().equalsIgnoreCase("error"))
                {
                    answer = "<string>" + USBTrans.fileAnswerParamsList.get(0).toString() + "</string>\r\n" + "<list>\r\n";
                    for(int i = 0; i < USBTrans.hashVector.size(); i++)
                    {
                        answer = answer + "<hash ref=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(0) + "\" version=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(1) + "\">\r\n";
                        for(int j = 0; j < (((Vector)USBTrans.hashVector.elementAt(i)).size() - 2) / 3; j++)
                            answer = answer + "<val key=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 2) + "\">" + "<" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 1 + 2) + ">" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 2 + 2) + "</" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 1 + 2) + ">" + "</val>\r\n";

                        answer = answer + "</hash>\r\n";
                    }

                    answer = answer + "</list>";
                } else
                {
                    answer = "<error code=\"" + ((Vector)USBTrans.hashVector.elementAt(0)).elementAt(0) + "\">" + ((Vector)USBTrans.hashVector.elementAt(0)).elementAt(1) + "</error>";
                    if(((String)((Vector)USBTrans.hashVector.elementAt(0)).elementAt(0)).equalsIgnoreCase("600"))
                        setFileTransferRunningStateOff();
                }
            } else
            if(!USBTrans.fileAnswerParams[0].equalsIgnoreCase("error"))
            {
                answer = "<string>" + USBTrans.fileAnswerParams[0] + "</string>\r\n" + "<list>\r\n";
                for(int i = 0; i < USBTrans.hashVector.size(); i++)
                {
                    answer = answer + "<hash ref=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(0) + "\" version=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(1) + "\">\r\n";
                    for(int j = 0; j < (((Vector)USBTrans.hashVector.elementAt(i)).size() - 2) / 3; j++)
                        answer = answer + "<val key=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 2) + "\">" + "<" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 1 + 2) + ">" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 2 + 2) + "</" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 1 + 2) + ">" + "</val>\r\n";

                    answer = answer + "</hash>\r\n";
                }

                answer = answer + "</list>";
            } else
            {
                answer = "<error code=\"" + ((Vector)USBTrans.hashVector.elementAt(0)).elementAt(0) + "\">" + ((Vector)USBTrans.hashVector.elementAt(0)).elementAt(1) + "</error>";
                if(((String)((Vector)USBTrans.hashVector.elementAt(0)).elementAt(0)).equalsIgnoreCase("600"))
                    setFileTransferRunningStateOff();
            }
        return answer;
    }

    public String USBputContact(String request)
    {
        String answer = "";
        if(scanTinyRpcVectorFillDivespot(request) && USBTrans.getMethodAnswer("putContact", 2, 0))
            if(USBTrans.useListInsteadOfArray)
            {
                if(!USBTrans.fileAnswerParamsList.get(0).toString().equalsIgnoreCase("error"))
                {
                    answer = "<string>" + USBTrans.fileAnswerParamsList.get(0).toString() + "</string>\r\n" + "<list>\r\n";
                    for(int i = 0; i < USBTrans.hashVector.size(); i++)
                    {
                        answer = answer + "<hash ref=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(0) + "\" version=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(1) + "\">\r\n";
                        for(int j = 0; j < (((Vector)USBTrans.hashVector.elementAt(i)).size() - 2) / 3; j++)
                            answer = answer + "<val key=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 2) + "\">" + "<" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 1 + 2) + ">" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 2 + 2) + "</" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 1 + 2) + ">" + "</val>\r\n";

                        answer = answer + "</hash>\r\n";
                    }

                    answer = answer + "</list>";
                } else
                {
                    answer = "<error code=\"" + ((Vector)USBTrans.hashVector.elementAt(0)).elementAt(0) + "\">" + ((Vector)USBTrans.hashVector.elementAt(0)).elementAt(1) + "</error>";
                    if(((String)((Vector)USBTrans.hashVector.elementAt(0)).elementAt(0)).equalsIgnoreCase("600"))
                        setFileTransferRunningStateOff();
                }
            } else
            if(!USBTrans.fileAnswerParams[0].equalsIgnoreCase("error"))
            {
                answer = "<string>" + USBTrans.fileAnswerParams[0] + "</string>\r\n" + "<list>\r\n";
                for(int i = 0; i < USBTrans.hashVector.size(); i++)
                {
                    answer = answer + "<hash ref=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(0) + "\" version=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(1) + "\">\r\n";
                    for(int j = 0; j < (((Vector)USBTrans.hashVector.elementAt(i)).size() - 2) / 3; j++)
                        answer = answer + "<val key=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 2) + "\">" + "<" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 1 + 2) + ">" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 2 + 2) + "</" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 1 + 2) + ">" + "</val>\r\n";

                    answer = answer + "</hash>\r\n";
                }

                answer = answer + "</list>";
            } else
            {
                answer = "<error code=\"" + ((Vector)USBTrans.hashVector.elementAt(0)).elementAt(0) + "\">" + ((Vector)USBTrans.hashVector.elementAt(0)).elementAt(1) + "</error>";
                if(((String)((Vector)USBTrans.hashVector.elementAt(0)).elementAt(0)).equalsIgnoreCase("600"))
                    setFileTransferRunningStateOff();
            }
        return answer;
    }

    public String USBgetDirectory(String request)
    {
        String answer = "";
        boolean error = false;
        int numParamsIn = scanTinyRpcList(request);
        if(USBTrans.getMethodAnswer("getDirectory", numParamsIn, 0))
        {
            if(USBTrans.fileAnswerParamsList.get(0).toString().equalsIgnoreCase("error"))
            {
                error = true;
                TriggerRunningStateOff = true;
            }
            if(((Vector)USBTrans.hashVector.elementAt(0)).size() > 1)
            {
                if(USBTrans.useListInsteadOfArray)
                    answer = "<string>" + USBTrans.fileAnswerParamsList.get(0).toString() + "</string>\r\n" + "<list>\r\n";
                else
                    answer = "<string>" + USBTrans.fileAnswerParams[0] + "</string>\r\n" + "<list>\r\n";
                if(!error)
                {
                    for(int i = 0; i < USBTrans.hashVector.size(); i++)
                    {
                        answer = answer + "<hash ref=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(0) + "\" version=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(1) + "\">\r\n";
                        for(int j = 0; j < (((Vector)USBTrans.hashVector.elementAt(i)).size() - 2) / 3; j++)
                            answer = answer + "<val key=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 2) + "\">" + "<" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 1 + 2) + ">" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 2 + 2) + "</" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 1 + 2) + ">" + "</val>\r\n";

                        answer = answer + "</hash>\r\n";
                    }

                    answer = answer + "</list>";
                }
            } else
            if(USBTrans.useListInsteadOfArray)
                answer = "<string>" + USBTrans.fileAnswerParamsList.get(0).toString() + "</string>\r\n" + "<list />\r\n";
            else
                answer = "<string>" + USBTrans.fileAnswerParams[0] + "</string>\r\n" + "<list />\r\n";
            if(error && ((Vector)USBTrans.hashVector.elementAt(0)).size() > 1)
            {
                answer = "<error code=\"" + ((Vector)USBTrans.hashVector.elementAt(0)).elementAt(0) + "\">" + ((Vector)USBTrans.hashVector.elementAt(0)).elementAt(1) + "</error>\r\n";
                if(((String)((Vector)USBTrans.hashVector.elementAt(0)).elementAt(0)).equalsIgnoreCase("600"))
                    setFileTransferRunningStateOff();
            }
        }
        return answer;
    }

    public String USBgetDiveLog(String request)
    {
        String answer = "";
        boolean error = false;
        int numParamsIn = scanTinyRpcListNotListEnd(request);
        if(USBTrans.getMethodAnswer("getDivelogs", numParamsIn, 0))
        {
            if(USBTrans.fileAnswerParamsList.get(0).toString().equalsIgnoreCase("error"))
            {
                error = true;
                TriggerRunningStateOff = true;
            }
            if(((Vector)USBTrans.hashVector.elementAt(0)).size() > 1)
            {
                if(USBTrans.useListInsteadOfArray)
                    answer = "<string>" + USBTrans.fileAnswerParamsList.get(0).toString() + "</string>\r\n" + "<list>\r\n";
                else
                    answer = "<string>" + USBTrans.fileAnswerParams[0] + "</string>\r\n" + "<list>\r\n";
                if(!error)
                {
                    int i = 0;
                    for(i = 0; i < USBTrans.hashVector.size(); i++)
                    {
                        if(USBTrans.useListInsteadOfArray)
                            answer = answer + "<hash ref=\"" + USBTrans.fileAnswerParamsList.get(1).toString() + "\" version=\"" + USBTrans.fileAnswerParamsList.get(2).toString() + "\">\r\n";
                        else
                            answer = answer + "<hash ref=\"" + USBTrans.fileAnswerParams[1] + "\" version=\"" + USBTrans.fileAnswerParams[2] + "\">\r\n";
                        for(int j = 0; j < ((Vector)USBTrans.hashVector.elementAt(i)).size() / 3; j++)
                        {
                            answer = answer + "<val key=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3) + "\">\r\n";
                            if(((String)((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 1)).equalsIgnoreCase("bin"))
                                answer = answer + "<" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 1) + " format=\"base64\">";
                            else
                                answer = answer + "<" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 1) + ">";
                            answer = answer + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 2) + "</" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 1) + ">\r\n";
                            answer = answer + "</val>\r\n";
                        }

                        answer = answer + "</hash>\r\n";
                    }

                    System.out.println("We uploaded " + i + " Divelogs!\n");
                    answer = answer + "</list>";
                }
            } else
            if(USBTrans.useListInsteadOfArray)
                answer = "<string>" + USBTrans.fileAnswerParamsList.get(0).toString() + "</string>\r\n" + "<list />\r\n";
            else
                answer = "<string>" + USBTrans.fileAnswerParams[0] + "</string>\r\n" + "<list />\r\n";
            if(error)
                if(USBTrans.useListInsteadOfArray)
                {
                    answer = "<error code=\"" + USBTrans.fileAnswerParamsList.get(1).toString() + "\">" + USBTrans.fileAnswerParamsList.get(2).toString() + "</error>\r\n";
                    if(USBTrans.fileAnswerParamsList.get(1).toString().equalsIgnoreCase("600"))
                        setFileTransferRunningStateOff();
                } else
                {
                    answer = "<error code=\"" + USBTrans.fileAnswerParams[1] + "\">" + USBTrans.fileAnswerParams[2] + "</error>\r\n";
                    setFileTransferRunningStateOff();
                }
        }
        return answer;
    }

    public String USBgetDive(String request)
    {
        String answer = "";
        boolean error = false;
        int numParamsIn = scanTinyRpcList(request);
        int Offset = 0;
        int conditionElementsCounter = 6;
        int gearElementsCounter = 12;
        int buddyElementsCounter = 6;
        int buddySubElementCounter = 3;
        boolean conditionHit = false;
        boolean gearHit = false;
        boolean buddyHit = false;
        boolean atLeastOneBuddy = false;
        if(USBTrans.getMethodAnswer("getDive", numParamsIn, 0))
        {
            if(USBTrans.useListInsteadOfArray)
            {
                if(USBTrans.fileAnswerParamsList.get(0).toString().equalsIgnoreCase("error"))
                {
                    error = true;
                    TriggerRunningStateOff = true;
                } else
                {
                    answer = "<string>" + USBTrans.fileAnswerParamsList.get(0).toString() + "</string>\r\n" + "<list>\r\n";
                }
            } else
            {
                answer = "<string>" + USBTrans.fileAnswerParams[0] + "</string>\r\n" + "<list>\r\n";
            }
            if(!error && ((Vector)USBTrans.hashVector.elementAt(0)).size() > 2)
            {
                for(int i = 0; i < USBTrans.hashVector.size(); i++)
                {
                    if(USBTrans.useListInsteadOfArray)
                        answer = answer + "<hash ref=\"" + USBTrans.fileAnswerParamsList.get(1).toString() + "\" version=\"" + USBTrans.fileAnswerParamsList.get(2).toString() + "\">\r\n";
                    else
                        answer = answer + "<hash ref=\"" + USBTrans.fileAnswerParams[1] + "\" version=\"" + USBTrans.fileAnswerParams[2] + "\">\r\n";
                    Offset = 0;
                    conditionElementsCounter = 6;
                    gearElementsCounter = 12;
                    buddyElementsCounter = 6;
                    buddySubElementCounter = 3;
                    for(int j = 0; j < ((Vector)USBTrans.hashVector.elementAt(i)).size() / 3 - 1; j++)
                    {
                        if(USBTrans.useListInsteadOfArray)
                        {
                            if(buddyHit && buddySubElementCounter == 3 && !((String)((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + Offset)).equalsIgnoreCase("notes"))
                                answer = answer + "<hash ref=\"" + USBTrans.fileAnswerParamsList.get(7).toString() + "\" version=\"" + USBTrans.fileAnswerParamsList.get(8).toString() + "\">";
                        } else
                        if(buddyHit && buddySubElementCounter == 3 && !((String)((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + Offset)).equalsIgnoreCase("notes"))
                            answer = answer + "<hash ref=\"" + USBTrans.fileAnswerParams[7] + "\" version=\"" + USBTrans.fileAnswerParams[8] + "\">";
                        if(buddyHit && buddySubElementCounter == 3 && ((String)((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + Offset)).equalsIgnoreCase("notes"))
                        {
                            if(!atLeastOneBuddy)
                                answer = answer + "</hash>\r\n";
                            answer = answer + "</list>\r\n";
                            answer = answer + "</val>\r\n";
                        }
                        answer = answer + "<val key=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + Offset) + "\">\r\n";
                        if(((String)((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + Offset)).equalsIgnoreCase("conditions"))
                        {
                            Offset++;
                            conditionHit = true;
                            answer = answer + "<hash>";
                            answer = answer + "<val key=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + Offset) + "\">\r\n";
                        }
                        if(((String)((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + Offset)).equalsIgnoreCase("gear"))
                        {
                            Offset++;
                            gearHit = true;
                            answer = answer + "<hash>";
                            answer = answer + "<val key=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + Offset) + "\">\r\n";
                        }
                        if(((String)((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + Offset)).equalsIgnoreCase("buddies") && !((String)((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + Offset + 1)).equalsIgnoreCase("notes"))
                        {
                            Offset++;
                            buddyHit = true;
                            answer = answer + "<list>\r\n";
                            if(USBTrans.useListInsteadOfArray)
                                answer = answer + "<hash ref=\"" + USBTrans.fileAnswerParamsList.get(7).toString() + "\" version=\"" + USBTrans.fileAnswerParamsList.get(8).toString() + "\">";
                            else
                                answer = answer + "<hash ref=\"" + USBTrans.fileAnswerParams[7] + "\" version=\"" + USBTrans.fileAnswerParams[8] + "\">";
                            answer = answer + "<val key=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + Offset) + "\">\r\n";
                        } else
                        if(((String)((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + Offset)).equalsIgnoreCase("buddies") && ((String)((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + Offset + 1)).equalsIgnoreCase("notes"))
                        {
                            Offset++;
                            answer = answer + "<list/>\r\n";
                            answer = answer + "</val>\r\n";
                            answer = answer + "<val key=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + Offset) + "\">\r\n";
                        }
                        answer = answer + "<" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 1 + Offset) + ">" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 2 + Offset) + "</" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 1 + Offset) + ">\r\n";
                        answer = answer + "</val>\r\n";
                        if(buddyHit)
                            if(buddySubElementCounter == 3 && ((String)((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + Offset)).equalsIgnoreCase("notes"))
                            {
                                buddyHit = false;
                            } else
                            {
                                if(!atLeastOneBuddy)
                                    atLeastOneBuddy = true;
                                if(--buddySubElementCounter == 0)
                                {
                                    answer = answer + "</hash>\r\n";
                                    buddySubElementCounter = 3;
                                    if(--buddyElementsCounter == 0)
                                    {
                                        buddyHit = false;
                                        answer = answer + "</list>\r\n";
                                        answer = answer + "</val>\r\n";
                                    }
                                }
                            }
                        if(conditionHit && --conditionElementsCounter == 0)
                        {
                            conditionHit = false;
                            answer = answer + "</hash>\r\n";
                            answer = answer + "</val>\r\n";
                        }
                        if(gearHit && --gearElementsCounter == 0)
                        {
                            gearHit = false;
                            answer = answer + "</hash>\r\n";
                            answer = answer + "</val>\r\n";
                        }
                    }

                    answer = answer + "</hash>\r\n";
                }

                answer = answer + "</list>";
            } else
            if(!error)
                if(USBTrans.useListInsteadOfArray)
                    answer = "<string>" + USBTrans.fileAnswerParamsList.get(0).toString() + "</string>\r\n" + "<list />\r\n";
                else
                    answer = "<string>" + USBTrans.fileAnswerParams[0] + "</string>\r\n" + "<list />\r\n";
            if(error)
                if(USBTrans.useListInsteadOfArray)
                {
                    answer = "<error code=\"" + USBTrans.fileAnswerParamsList.get(1).toString() + "\">" + USBTrans.fileAnswerParamsList.get(2).toString() + "</error>\r\n";
                    if(USBTrans.fileAnswerParamsList.get(1).toString().equalsIgnoreCase("600"))
                        setFileTransferRunningStateOff();
                } else
                {
                    answer = "<error code=\"" + USBTrans.fileAnswerParams[1] + "\">" + USBTrans.fileAnswerParams[2] + "</error>\r\n";
                    setFileTransferRunningStateOff();
                }
        }
        return answer;
    }

    public String USBgetUserSettings(String request)
    {
        String answer = "";
        int numParamsIn = scanTinyRpcList(request);
        int Offset = 0;
        boolean error = false;
        boolean educationHit = false;
        boolean timeDateHit = false;
        boolean profileHit = false;
        boolean unitHit = false;
        boolean medicalHit = false;
        if(USBTrans.getMethodAnswer("getUserSettings", numParamsIn, 0))
        {
            if(USBTrans.fileAnswerParamsList.get(0).toString().equalsIgnoreCase("error"))
            {
                error = true;
                TriggerRunningStateOff = true;
            } else
            {
                answer = "<string>" + USBTrans.fileAnswerParamsList.get(0).toString() + "</string>\r\n" + "<list>\r\n";
            }
            if(!error && ((Vector)USBTrans.hashVector.elementAt(0)).size() > 2)
            {
                for(int i = 0; i < USBTrans.hashVector.size(); i++)
                {
                    if(USBTrans.useListInsteadOfArray)
                        answer = answer + "<hash ref=\"" + USBTrans.fileAnswerParamsList.get(1).toString() + "\" version=\"" + USBTrans.fileAnswerParamsList.get(2).toString() + "\">\r\n";
                    else
                        answer = answer + "<hash ref=\"" + USBTrans.fileAnswerParams[1] + "\" version=\"" + USBTrans.fileAnswerParams[2] + "\">\r\n";
                    int educationElementsCounter = 5;
                    int timeDateElementsCounter = 4;
                    int profileElementsCounter = 4;
                    int unitElementsCounter = 7;
                    int medicalElementsCounter = 6;
                    Offset = 0;
                    for(int j = 0; j < (((Vector)USBTrans.hashVector.elementAt(i)).size() - 4) / 3; j++)
                    {
                        if(USBTrans.useListInsteadOfArray)
                        {
                            if(educationHit && educationElementsCounter == 5)
                                answer = answer + "<hash>";
                        } else
                        if(educationHit && educationElementsCounter == 5)
                            answer = answer + "<hash>";
                        if(!((String)((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + Offset)).equalsIgnoreCase("education") || ((String)((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + Offset)).equalsIgnoreCase("education") && !((String)((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + Offset + 1)).equalsIgnoreCase("profile"))
                            answer = answer + "<val key=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + Offset) + "\">\r\n";
                        else
                        if(((String)((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + Offset)).equalsIgnoreCase("education") && ((String)((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + Offset + 1)).equalsIgnoreCase("profile"))
                        {
                            answer = answer + "<val key=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + Offset) + "\">\r\n";
                            answer = answer + "<list/>\r\n";
                            answer = answer + "</val>\r\n";
                            answer = answer + "<val key=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + Offset + 1) + "\">\r\n";
                        }
                        if(((String)((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + Offset)).equalsIgnoreCase("education"))
                        {
                            Offset++;
                            if(!((String)((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + Offset)).equalsIgnoreCase("profile"))
                            {
                                educationHit = true;
                                answer = answer + "<list>";
                                answer = answer + "<hash>";
                                answer = answer + "<val key=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + Offset) + "\">\r\n";
                            }
                        }
                        if(((String)((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + Offset)).equalsIgnoreCase("timedate"))
                        {
                            Offset++;
                            timeDateHit = true;
                            answer = answer + "<hash>";
                            answer = answer + "<val key=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + Offset) + "\">\r\n";
                        }
                        if(((String)((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + Offset)).equalsIgnoreCase("medical"))
                        {
                            Offset++;
                            medicalHit = true;
                            answer = answer + "<hash>";
                            answer = answer + "<val key=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + Offset) + "\">\r\n";
                        }
                        if(((String)((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + Offset)).equalsIgnoreCase("profile"))
                        {
                            Offset++;
                            profileHit = true;
                            answer = answer + "<hash>";
                            answer = answer + "<val key=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + Offset) + "\">\r\n";
                        }
                        if(((String)((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + Offset)).equalsIgnoreCase("unit"))
                        {
                            Offset++;
                            unitHit = true;
                            answer = answer + "<hash>";
                            answer = answer + "<val key=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + Offset) + "\">\r\n";
                        }
                        answer = answer + "<" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 1 + Offset) + ">" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 2 + Offset) + "</" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 1 + Offset) + ">\r\n";
                        answer = answer + "</val>\r\n";
                        if(educationHit && --educationElementsCounter == 0)
                        {
                            answer = answer + "</hash>\r\n";
                            if(((String)((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + Offset + 3)).equalsIgnoreCase("profile"))
                            {
                                educationHit = false;
                                answer = answer + "</list>\r\n";
                                answer = answer + "</val>\r\n";
                            } else
                            {
                                educationElementsCounter = 5;
                            }
                        }
                        if(timeDateHit && --timeDateElementsCounter == 0)
                        {
                            timeDateHit = false;
                            answer = answer + "</hash>\r\n";
                            answer = answer + "</val>\r\n";
                        }
                        if(medicalHit && --medicalElementsCounter == 0)
                        {
                            medicalHit = false;
                            answer = answer + "</hash>\r\n";
                            answer = answer + "</val>\r\n";
                        }
                        if(profileHit && --profileElementsCounter == 0)
                        {
                            profileHit = false;
                            answer = answer + "</hash>\r\n";
                            answer = answer + "</val>\r\n";
                        }
                        if(unitHit && --unitElementsCounter == 0)
                        {
                            unitHit = false;
                            answer = answer + "</hash>\r\n";
                            answer = answer + "</val>\r\n";
                        }
                    }

                    answer = answer + "</hash>\r\n";
                }

                answer = answer + "</list>";
            } else
            if(!error)
                if(USBTrans.useListInsteadOfArray)
                    answer = "<string>" + USBTrans.fileAnswerParamsList.get(0).toString() + "</string>\r\n" + "<list />\r\n";
                else
                    answer = "<string>" + USBTrans.fileAnswerParams[0] + "</string>\r\n" + "<list />\r\n";
            if(error)
                if(USBTrans.useListInsteadOfArray)
                {
                    answer = "<error code=\"" + USBTrans.fileAnswerParamsList.get(1).toString() + "\">" + USBTrans.fileAnswerParamsList.get(2).toString() + "</error>\r\n";
                    if(USBTrans.fileAnswerParamsList.get(1).toString().equalsIgnoreCase("600"))
                        setFileTransferRunningStateOff();
                } else
                {
                    answer = "<error code=\"" + USBTrans.fileAnswerParams[1] + "\">" + USBTrans.fileAnswerParams[2] + "</error>\r\n";
                    setFileTransferRunningStateOff();
                }
        }
        return answer;
    }

    public String USBgetChecklist(String request)
    {
        String answer = "";
        boolean error = false;
        int numParamsIn = scanTinyRpcList(request);
        int Offset = 0;
        boolean entriesHit = false;
        if(USBTrans.getMethodAnswer("getChecklist", numParamsIn, 0))
        {
            if(USBTrans.fileAnswerParamsList.get(0).toString().equalsIgnoreCase("error"))
            {
                error = true;
                TriggerRunningStateOff = true;
            } else
            {
                answer = "<string>" + USBTrans.fileAnswerParamsList.get(0).toString() + "</string>\r\n" + "<list>\r\n";
            }
            if(!error && ((Vector)USBTrans.hashVector.elementAt(0)).size() > 2)
            {
                for(int i = 0; i < USBTrans.hashVector.size(); i++)
                {
                    if(USBTrans.useListInsteadOfArray)
                        answer = answer + "<hash ref=\"" + USBTrans.fileAnswerParamsList.get(1).toString() + "\" version=\"" + USBTrans.fileAnswerParamsList.get(2).toString() + "\">\r\n";
                    else
                        answer = answer + "<hash ref=\"" + USBTrans.fileAnswerParams[1] + "\" version=\"" + USBTrans.fileAnswerParams[2] + "\">\r\n";
                    int entriesElementsCounter = 2;
                    Offset = 0;
                    for(int j = 0; j < (((Vector)USBTrans.hashVector.elementAt(i)).size() - 1) / 3; j++)
                    {
                        if(USBTrans.useListInsteadOfArray)
                        {
                            if(entriesHit && entriesElementsCounter == 2)
                                answer = answer + "<hash>";
                        } else
                        if(entriesHit && entriesElementsCounter == 2)
                            answer = answer + "<hash>";
                        if(!((String)((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + Offset)).equalsIgnoreCase("entries") || ((String)((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + Offset)).equalsIgnoreCase("entries") && (((Vector)USBTrans.hashVector.elementAt(i)).size() - 1) / 3 - 1 > j)
                            answer = answer + "<val key=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + Offset) + "\">\r\n";
                        if(((String)((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + Offset)).equalsIgnoreCase("entries"))
                        {
                            Offset++;
                            entriesHit = true;
                            answer = answer + "<list>";
                            if((((Vector)USBTrans.hashVector.elementAt(i)).size() - 1) / 3 - 1 > j)
                            {
                                answer = answer + "<hash>";
                                answer = answer + "<val key=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + Offset) + "\">\r\n";
                            }
                        }
                        answer = answer + "<" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 1 + Offset) + ">" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 2 + Offset) + "</" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 1 + Offset) + ">\r\n";
                        answer = answer + "</val>\r\n";
                        if((((Vector)USBTrans.hashVector.elementAt(i)).size() - 1) / 3 - 1 == j && ((String)((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 3)).equalsIgnoreCase("entries"))
                        {
                            answer = answer + "<val key=\"entries\">\r\n";
                            answer = answer + "<list/>\r\n";
                            answer = answer + "</val>\r\n";
                        }
                        if(entriesHit && --entriesElementsCounter == 0)
                        {
                            answer = answer + "</hash>\r\n";
                            if((((Vector)USBTrans.hashVector.elementAt(i)).size() - 1) / 3 - 1 == j)
                            {
                                entriesHit = false;
                                answer = answer + "</list>\r\n";
                                answer = answer + "</val>\r\n";
                            } else
                            {
                                entriesElementsCounter = 2;
                            }
                        }
                    }

                    answer = answer + "</hash>\r\n";
                }

                answer = answer + "</list>";
            } else
            if(!error)
                if(USBTrans.useListInsteadOfArray)
                    answer = "<string>" + USBTrans.fileAnswerParamsList.get(0).toString() + "</string>\r\n" + "<list />\r\n";
                else
                    answer = "<string>" + USBTrans.fileAnswerParams[0] + "</string>\r\n" + "<list />\r\n";
            if(error)
                if(USBTrans.useListInsteadOfArray)
                {
                    answer = "<error code=\"" + USBTrans.fileAnswerParamsList.get(1).toString() + "\">" + USBTrans.fileAnswerParamsList.get(2).toString() + "</error>\r\n";
                    if(USBTrans.fileAnswerParamsList.get(1).toString().equalsIgnoreCase("600"))
                        setFileTransferRunningStateOff();
                } else
                {
                    answer = "<error code=\"" + USBTrans.fileAnswerParams[1] + "\">" + USBTrans.fileAnswerParams[2] + "</error>\r\n";
                    setFileTransferRunningStateOff();
                }
        }
        return answer;
    }

    public String USBgetContact(String request)
    {
        String answer = "";
        boolean error = false;
        int numParamsIn = scanTinyRpcList(request);
        if(USBTrans.getMethodAnswer("getContact", numParamsIn, 0))
        {
            if(USBTrans.useListInsteadOfArray)
            {
                if(USBTrans.fileAnswerParamsList.get(0).toString().equalsIgnoreCase("error"))
                {
                    error = true;
                    TriggerRunningStateOff = true;
                } else
                {
                    answer = "<string>" + USBTrans.fileAnswerParamsList.get(0).toString() + "</string>\r\n" + "<list>\r\n";
                }
            } else
            {
                answer = "<string>" + USBTrans.fileAnswerParams[0] + "</string>\r\n" + "<list>\r\n";
            }
            if(!error && ((Vector)USBTrans.hashVector.elementAt(0)).size() > 2)
            {
                for(int i = 0; i < USBTrans.hashVector.size(); i++)
                {
                    if(USBTrans.useListInsteadOfArray)
                        answer = answer + "<hash ref=\"" + USBTrans.fileAnswerParamsList.get(1).toString() + "\" version=\"" + USBTrans.fileAnswerParamsList.get(2).toString() + "\">\r\n";
                    else
                        answer = answer + "<hash ref=\"" + USBTrans.fileAnswerParams[1] + "\" version=\"" + USBTrans.fileAnswerParams[2] + "\">\r\n";
                    for(int j = 0; j < ((Vector)USBTrans.hashVector.elementAt(i)).size() / 3; j++)
                    {
                        answer = answer + "<val key=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3) + "\">\r\n";
                        answer = answer + "<" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 1) + ">" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 2) + "</" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 1) + ">\r\n";
                        answer = answer + "</val>\r\n";
                    }

                    answer = answer + "</hash>\r\n";
                }

                answer = answer + "</list>";
            } else
            if(!error)
                if(USBTrans.useListInsteadOfArray)
                    answer = "<string>" + USBTrans.fileAnswerParamsList.get(0).toString() + "</string>\r\n" + "<list />\r\n";
                else
                    answer = "<string>" + USBTrans.fileAnswerParams[0] + "</string>\r\n" + "<list />\r\n";
            if(error)
                if(USBTrans.useListInsteadOfArray)
                {
                    answer = "<error code=\"" + USBTrans.fileAnswerParamsList.get(1).toString() + "\">" + USBTrans.fileAnswerParamsList.get(2).toString() + "</error>\r\n";
                    if(USBTrans.fileAnswerParamsList.get(1).toString().equalsIgnoreCase("600"))
                        setFileTransferRunningStateOff();
                } else
                {
                    answer = "<error code=\"" + USBTrans.fileAnswerParams[1] + "\">" + USBTrans.fileAnswerParams[2] + "</error>\r\n";
                    setFileTransferRunningStateOff();
                }
        }
        return answer;
    }

    public String USBgetDivespot(String request)
    {
        String answer = "";
        boolean error = false;
        int numParamsIn = scanTinyRpcList(request);
        System.out.println("this.USBTrans.getMethodAnswer(\"getDivespot\"," + numParamsIn + ",0)");
        if(USBTrans.getMethodAnswer("getDivespot", numParamsIn, 0))
        {
            System.out.println("this.USBTrans.getMethodAnswer(\"getDivespot\"," + numParamsIn + ",0) returned true");
            if(USBTrans.useListInsteadOfArray)
            {
                if(USBTrans.fileAnswerParamsList.get(0).toString().equalsIgnoreCase("error"))
                {
                    error = true;
                    TriggerRunningStateOff = true;
                } else
                {
                    answer = "<string>" + USBTrans.fileAnswerParamsList.get(0).toString() + "</string>\r\n" + "<list>\r\n";
                }
            } else
            {
                answer = "<string>" + USBTrans.fileAnswerParams[0] + "</string>\r\n" + "<list>\r\n";
            }
            if(!error && ((Vector)USBTrans.hashVector.elementAt(0)).size() > 2)
            {
                for(int i = 0; i < USBTrans.hashVector.size(); i++)
                {
                    if(USBTrans.useListInsteadOfArray)
                        answer = answer + "<hash ref=\"" + USBTrans.fileAnswerParamsList.get(1).toString() + "\" version=\"" + USBTrans.fileAnswerParamsList.get(2).toString() + "\">\r\n";
                    else
                        answer = answer + "<hash ref=\"" + USBTrans.fileAnswerParams[1] + "\" version=\"" + USBTrans.fileAnswerParams[2] + "\">\r\n";
                    for(int j = 0; j < ((Vector)USBTrans.hashVector.elementAt(i)).size() / 3; j++)
                    {
                        answer = answer + "<val key=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3) + "\">\r\n";
                        answer = answer + "<" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 1) + ">" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 2) + "</" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 1) + ">\r\n";
                        answer = answer + "</val>\r\n";
                    }

                    answer = answer + "</hash>\r\n";
                }

                answer = answer + "</list>";
            } else
            if(!error)
                if(USBTrans.useListInsteadOfArray)
                    answer = "<string>" + USBTrans.fileAnswerParamsList.get(0).toString() + "</string>\r\n" + "<list />\r\n";
                else
                    answer = "<string>" + USBTrans.fileAnswerParams[0] + "</string>\r\n" + "<list />\r\n";
            if(error)
                if(USBTrans.useListInsteadOfArray)
                {
                    answer = "<error code=\"" + USBTrans.fileAnswerParamsList.get(1).toString() + "\">" + USBTrans.fileAnswerParamsList.get(2).toString() + "</error>\r\n";
                    if(USBTrans.fileAnswerParamsList.get(1).toString().equalsIgnoreCase("600"))
                        setFileTransferRunningStateOff();
                } else
                {
                    answer = "<error code=\"" + USBTrans.fileAnswerParams[1] + "\">" + USBTrans.fileAnswerParams[2] + "</error>\r\n";
                    setFileTransferRunningStateOff();
                }
        }
        return answer;
    }

    public String USBgetDeviceData(String request)
    {
        String answer = "";
        boolean error = false;
        int numParamsIn = scanTinyRpcList(request);
        if(USBTrans.getMethodAnswer("getDeviceData", numParamsIn, 0))
        {
            if(USBTrans.useListInsteadOfArray)
            {
                if(USBTrans.fileAnswerParamsList.get(0).toString().equalsIgnoreCase("error"))
                {
                    error = true;
                    TriggerRunningStateOff = true;
                } else
                {
                    answer = "<string>" + USBTrans.fileAnswerParamsList.get(0).toString() + "</string>\r\n" + "<list>\r\n";
                }
            } else
            if(USBTrans.fileAnswerParams[0].equalsIgnoreCase("error"))
            {
                error = true;
                TriggerRunningStateOff = true;
            } else
            {
                answer = "<string>" + USBTrans.fileAnswerParams[0] + "</string>\r\n" + "<list>\r\n";
            }
            if(!error && ((Vector)USBTrans.hashVector.elementAt(0)).size() > 2)
            {
                for(int i = 0; i < USBTrans.hashVector.size(); i++)
                {
                    if(USBTrans.useListInsteadOfArray)
                        answer = answer + "<hash ref=\"" + USBTrans.fileAnswerParamsList.get(1).toString() + "\" version=\"" + USBTrans.fileAnswerParamsList.get(2).toString() + "\">\r\n";
                    else
                        answer = answer + "<hash ref=\"" + USBTrans.fileAnswerParams[1] + "\" version=\"" + USBTrans.fileAnswerParams[2] + "\">\r\n";
                    for(int j = 0; j < ((Vector)USBTrans.hashVector.elementAt(i)).size() / 3; j++)
                    {
                        answer = answer + "<val key=\"" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3) + "\">\r\n";
                        answer = answer + "<" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 1) + ">" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 2) + "</" + ((Vector)USBTrans.hashVector.elementAt(i)).elementAt(j * 3 + 1) + ">\r\n";
                        answer = answer + "</val>\r\n";
                    }

                    answer = answer + "</hash>\r\n";
                }

                answer = answer + "</list>";
            } else
            if(!error)
                if(USBTrans.useListInsteadOfArray)
                    answer = "<string>" + USBTrans.fileAnswerParamsList.get(0).toString() + "</string>\r\n" + "<list />\r\n";
                else
                    answer = "<string>" + USBTrans.fileAnswerParams[0] + "</string>\r\n" + "<list />\r\n";
            if(error)
                if(USBTrans.useListInsteadOfArray)
                {
                    answer = "<error code=\"" + USBTrans.fileAnswerParamsList.get(1).toString() + "\">" + USBTrans.fileAnswerParamsList.get(2).toString() + "</error>\r\n";
                    if(USBTrans.fileAnswerParamsList.get(1).toString().equalsIgnoreCase("600"))
                        setFileTransferRunningStateOff();
                } else
                {
                    answer = "<error code=\"" + USBTrans.fileAnswerParams[1] + "\">" + USBTrans.fileAnswerParams[2] + "</error>\r\n";
                    setFileTransferRunningStateOff();
                }
        }
        return answer;
    }

    public String USBgetUserSettingsAck(String request)
    {
        String answer = "";
        if(scanTinyRpcVectorFillDivespot(request))
        {
            USBTrans.getMethodAnswer("getUserSettingsAck", 2, 0);
            if(USBTrans.fileAnswerParamsList.get(0).toString().equalsIgnoreCase("error"))
            {
                TriggerRunningStateOff = true;
                answer = "<error code=\"600\">Out of Memory</error>\r\n";
                setFileTransferRunningStateOff();
            } else
            {
                answer = "<bool>true</bool>\r\n";
            }
        }
        return answer;
    }

    public String USBgetChecklistAck(String request)
    {
        String answer = "";
        if(scanTinyRpcVectorFillDivespot(request))
        {
            USBTrans.getMethodAnswer("getChecklistAck", 2, 0);
            if(USBTrans.fileAnswerParamsList.get(0).toString().equalsIgnoreCase("error"))
            {
                TriggerRunningStateOff = true;
                answer = "<error code=\"600\">Out of Memory</error>\r\n";
                setFileTransferRunningStateOff();
            } else
            {
                answer = "<bool>true</bool>\r\n";
            }
        }
        return answer;
    }

    public String USBgetContactAck(String request)
    {
        String answer = "";
        if(scanTinyRpcVectorFillDivespot(request))
        {
            USBTrans.getMethodAnswer("getContactAck", 2, 0);
            if(USBTrans.fileAnswerParamsList.get(0).toString().equalsIgnoreCase("error"))
            {
                TriggerRunningStateOff = true;
                answer = "<error code=\"600\">Out of Memory</error>\r\n";
                setFileTransferRunningStateOff();
            } else
            {
                answer = "<bool>true</bool>\r\n";
            }
        }
        return answer;
    }

    public String USBgetDivespotAck(String request)
    {
        String answer = "";
        if(scanTinyRpcVectorFillDivespot(request))
        {
            USBTrans.getMethodAnswer("getDivespotAck", 2, 0);
            if(USBTrans.fileAnswerParamsList.get(0).toString().equalsIgnoreCase("error"))
            {
                TriggerRunningStateOff = true;
                answer = "<error code=\"600\">Out of Memory</error>\r\n";
                setFileTransferRunningStateOff();
            } else
            {
                answer = "<bool>true</bool>\r\n";
            }
        }
        return answer;
    }

    public String USBgetDiveAck(String request)
    {
        String answer = "";
        if(scanTinyRpcVectorFillDivespot(request))
        {
            USBTrans.getMethodAnswer("getDiveAck", 2, 0);
            if(USBTrans.fileAnswerParamsList.get(0).toString().equalsIgnoreCase("error"))
            {
                TriggerRunningStateOff = true;
                answer = "<error code=\"600\">Out of Memory</error>\r\n";
                setFileTransferRunningStateOff();
            } else
            {
                answer = "<bool>true</bool>\r\n";
            }
        }
        return answer;
    }

    public String USBterminateSync(String request)
    {
        String answer = "";
        if(scanTinyRpc(request, 1, "<args") && USBTrans.getMethodAnswer("terminateSync", 1, 1))
            if(USBTrans.useListInsteadOfArray)
                answer = "<string>" + USBTrans.fileAnswerParamsList.get(0).toString() + "</string>";
            else
                answer = "<string>" + USBTrans.fileAnswerParams[0] + "</string>";
        return answer;
    }

    public void USBleaveBlockView()
    {
        USBTrans.getMethodAnswer("leaveBlockView", 0, 0);
    }

    private USBFileCommunication USBTrans;
    private USBILR ilr;
    private USBwriteVal writeVal;
    public String tunnelString;
    private static tinyRPCMaster singelton = null;
    private Properties dataServerHashTable;
    private boolean TriggerRunningStateOff;
    private TextField UNPWFields[];

}
